﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Windows;
using System.Runtime.CompilerServices;
using System.Reflection;
using Infragistics.Windows.Themes;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;
using System.Threading;

namespace PerformanceTestVehicle
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        //please change the setting to this property to toggle preloading
        //preloading is now enabled (true) improving user-initiated startup time
        //if disabled (false) initial startup time will increase
        private bool _isPreloaded = true;

        public bool IsPreloaded
        {
            get
            {
                return _isPreloaded;
            }
        }
        private Thread preloadThread = null;
        protected override void OnStartup(StartupEventArgs e)
        {
            if (_isPreloaded)
            {
                //preload the controls in the PreloadWindow in a separate thread
                //subsequent invocations of these controls will be much faster
                //as their MSIL code would be already JIT-ted
                preloadThread = new Thread(() =>
                {
                    PreloadWindow loader = new PreloadWindow();
                    loader.WindowStartupLocation = WindowStartupLocation.Manual;
                    loader.Top = Int16.MaxValue;
                    loader.ShowInTaskbar = false;

                    loader.Show();
                    loader.Close();
                });
                preloadThread.IsBackground = true;
                preloadThread.SetApartmentState(ApartmentState.STA);
                preloadThread.Start();
            }

            base.OnStartup(e);
        }

        protected override void OnExit(ExitEventArgs e)
        {
            //abort the thread if preloading
            if (preloadThread != null)
                preloadThread.Abort();

            base.OnExit(e);
        }
    }
}
